#include <csl_mcbsp.h>
#include <csl_pll.h>
#include <csl_irq.h>
#include <csl_dma.h>
#include <extaddr.h>
#define WORD unsigned short
#define zz       *(WORD*)
WORD machine,d_m,dpi,p6,h999,i35,i75;    // 2014,4,22
int job,ist4;                    // error_4 stop marker.
int cutdone;
WORD *usb2;
WORD *tmp = (WORD*)0x4800;       // 0xa00 -- 0x10c0

short *xx    =     (short*)0x5200; // 1924  for test_paper     
short *xy    =     (short*)0x5984; //  700
short *yy    =     (short*)0x5c40; //  864
short *ab    =     (short*)0x5fa0; //  864

WORD *aa    =     (WORD*)0x58c0; // a40  41*64
#define usb_address     (0x6300) // 800  512*4
WORD *usb1,*usb2;
WORD u1=0,u2=0;                  // W/R USB, pointer  0~3
#define hb_tbl          (0x6b00) // 1440  1728*3
// free                 (0x7f40)
#define REG_SW_VER      (0x7F80) // version
#define REG_RE_CONF     (0x7F81) // status of i/o_port [0x3401]
#define REG_DSP_SR      (0x7F82) // c5502 alive
#define REG_PG_status   (0x7F83) // 1start 2: end; c52 set 0
#define REG_DSP_IDX     (0x7F84) // DSP: A0dsp0; B1dsp1
#define REG_PAGE_IDX    (0x7F85) // ɨҳˮ
#define REG_LINE_IDX    (0x7F86) // ɨк
#define REG_EINT_CNT    (0x7F87) // 
#define REG_RX0INT_CNT  (0x7F88) // dmaͨ0жϴ
#define REG_RX1INT_CNT  (0x7F89) // dmaͨ1жϴ
#define REG_RX2INT_CNT  (0x7F8A) // dmaͨ2жϴ
#define REG_LINE_CNT    (0x7F8B) // ÿӲ1ݣ+1
#define REG_TXINT_CNT   (0x7F8C) // ÿfifoһݣ+1
#define REG_NORM_EN     (0x7F8D) // nouse ʹܹһ
#define REG_GAMMA_EN    (0x7F8E) // nouse ʹGAMMAУ
#define REG_DMAOUT_CNT  (0x7F8F) // nouse ʹGAMMAУ
#define REG_SCAN_DPI    (0x7F90) //       ǰɨֱ
#define REG_SCAN_LAYERS (0x7F91) // 0: none,(system forbit) 1: red, 2: blue
//                      (0x7f92) // if ==0, not use normalize coff.
//                      (0x7f93) up    set: omr_sort 0,1,2,3,9
//                      (0x7f94) c5502 set: omr_sort
//                      (0x7f95)       set: XGD
//                      (0x7f96) up    set: scale
//                      (0x7f97)       set: shift
//                      (0x7f98) // job;  if=1, do mormal; if==0, do XGD
//   free here
//                      (0x7f9f) // m255, !=0 posi_red_line output
//                      (0x7fa0) // n41
WORD     *p41   = (WORD*)0x7fa1; // 41 position
//                      (0x7fca) // barT,barX,barY,barL
//                      (0x7fce) // if=1, n41 not auto adjust.
//                      (0x7fcf) // if=1; similate B size by A machine
WORD *stop   =    (WORD*)0x7fd0; // 4~6
// 7fd4 --  free
//cut bar parameter
//                       0x7ffa   n1
//                       0x7ffb   n2
//                       0x7ffc   n3
//
//                       0x7ffe   topM
//                       0x7fff   endM

WORD end40;

#define n48    41           /* omr data number of a line */
#define half   24           /* 64: 30-12,27-11,26-7,25-6;24-7,23-6,22-9 */
#define p3     3            /* ignor  value */
#define sigma  3            /* bias,  edge, m20 */
#define sig20  3            /* bias,  edge, m20 */
#define m5     3            /* 0-m5 no 3bit out */
//#define p6     4,8        /* mark minum width 8 poshort  ~15,16 */
#define hwmax 30
#define hw     6
#define m60   55
#define m40   40
#define p10   15            /* old is 9, too small */
#define white8 8
int  p40,p60;               /* little adjusted in processing routine */
int  jp,x_c,x_w,c,cc,n41,bias3;
int  error,nx,ns,ipeak,xpeak,xpeak0,ipp,dp,dx,shift;
int  slip[41],bias[41],c_xpeak[41], a[41];
int  b[600], bz, bip, bs;    /* -- bar par -- */
WORD barT,barX,barY,barL, topM,endM, m255,topM10;   // topM10 counter
                                                    // delay 10 int0
int  mta[108]={
0x455,0x545,0x554,0x116,0x125,0x215,0x152,0x161,0x251,0x512,0x521,0x611,
0x059,0x149,0x158,0x095,0x185,0x194,0x590,0x509,0x518,0x491,0x581,0x848,
0x815,0x905,0x914,0x851,0x941,0x950,0x446,0x464,0x644,0x026,0x206,0x224,
0x062,0x242,0x260,0x422,0x602,0x620,0x04a,0x068,0x248,0x086,0x0a4,0x284,
0x884,0x428,0x608,0x482,0x4a0,0x488,0x806,0x824,0xa04,0x842,0x860,0xa40,
0x8c0,0x530,0xe00,0x017,0x035,0x107,0x134,0x305,0x314,0x053,0x071,0x143,
0x170,0x341,0x350,0x710,0x503,0xc80,0x701,0x2c0,0x01d,0x10d,0x11c,0x0d1,
0x1c1,0x1d0,0xc11,0xd01,0xd10,0x44c,0x4c4,0xc44,0x00e,0x02c,0x20c,0x0c2,
0x0e0,0xc02,0xc20,0x08c,0x0c8,0x80c,0xc08,0x431,0x413,0x419,0x680,0x40a};

int initXGD,docut38;
int j1,j2,j3,j4, n1,n2,n3;
float x,z;
#define gym 5
float zgym[gym]={ 16.62, 19.63, 19.96, 21.62, 20.00 };
int   igym[gym]={  0,  0, -5, -9, 0 };
//char  cgym[gym]={ 'T','G','Y','M','N'};

inline void FifoTransferRelease()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) &= ~(0x01<<2);
  else PREG16(0x3401) &= ~(0x01<<6);
  far_poke(0x8001,0x5a3c);
}
inline void MotorRestart()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) |= (0x01<<7);
  else PREG16(0x3401) |= (0x01<<4);        asm(" nop ");
}
inline void MotorStop()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) &= ~(0x01<<7);
  else PREG16(0x3401) &= ~(0x01<<4);
}
inline void TryFifoTransferRequest()
{
  if(REG16(REG_DSP_IDX)==0) PREG16(0x3401) |= (0x01<<2);
  else PREG16(0x3401) |= (0x01<<6);        asm(" nop ");
}
inline Uint16 CheckFifoTransferAck()
{
  if(REG16(REG_DSP_IDX)==0) return !(PREG16(0x3401)&0x10);
  else return !(PREG16(0x3401)&0x80);
}
volatile MCBSP_Handle hMcbsp0, hMcbsp1, hMcbsp2;
volatile DMA_Handle hDma0, hDma1, hDma2;
volatile DMA_Handle hDmaOut;
volatile Uint16 DmaEventID0;
volatile Uint16 DmaEventID1;
volatile Uint16 DmaEventID2;
volatile Uint16 DmaEventOutID;
volatile Uint16 McbspEventID;
void init_pll(void);
void init_dmaAD( Uint16 *info);
static interrupt void DmaISR0(void);
static interrupt void DmaISR1(void);
static interrupt void DmaISR2(void);
static interrupt void Int0ISR(void);
static interrupt void Int2ISR(void);
static interrupt void DmaOutISR(void);
void InitFifoInf(void);
extern void VECSTART(void);

Uint16  bufping[1728];
Uint16  bufpong[1728];
Uint16  *BufMain=bufping, *BufDma=NULL;
Uint16  FIRST = 0;
volatile unsigned long FifoBase[4];
volatile Uint16 OutFifoBusy = 0;
volatile Uint16 OutDmaBusy  = 0;
volatile Uint16 CurLayer;
volatile Uint16 CurPageNo;
volatile int fch,old_fch;
Uint8    BlockNum;

enum{ ST_Idle = 0, ST_Scan };
volatile Uint16 CS = ST_Idle;

#define PAD_MAGIC_1 0x1234
#define PAD_MAGIC_2 0x5678
#define START_PAD 1
#define END_PAD   2

struct PadItem{
  Uint16 magic_a;
  Uint16 magic_b;
  Uint16 magic_c;
  Uint16 magic_d;
  Uint16 pad_type;
  Uint16 page_no;
  Uint16 page_dpi;
  Uint16 chksum;
};
struct PadItem PagePad;
#define PAD_SIZE 8
Uint16 *pagepad;

struct BlockPadItem{
  Uint8 magic_1;
  Uint8 magic_2;
  Uint8 magic_3;
  Uint8 magic_4;
  Uint8 magic_5;
  Uint8 magic_6;
  Uint8 magic_7;
  Uint8 magic_8;
  Uint8 magic_9;
  Uint8 Block_lengh_L;
  Uint8 Block_lengh_H;
  Uint8 Block_type;
};
struct BlockPadItem BlockPad;
#define BLOCKPAD_SIZE 12
Uint8 *blockpad;

ioport volatile WORD *ConMcbsp2  = (ioport volatile WORD*)0x6c00;
MCBSP_Config McbspRcvConfig = {
  MCBSP_SPCR1_RMK(
    MCBSP_SPCR1_DLB_OFF,                   /* DLB    = 0 */
    MCBSP_SPCR1_RJUST_RZF,                 /* RJUST  = 0 */
    MCBSP_SPCR1_CLKSTP_DISABLE,            /* CLKSTP = 0 */
    MCBSP_SPCR1_DXENA_NA,                  /* DXENA  = 0 */
    MCBSP_SPCR1_ABIS_DISABLE,              /* ABIS   = 0 */
    MCBSP_SPCR1_RINTM_RRDY,                /* RINTM  = 0 */
    0,                                     /* RSYNCER= 0 */
    MCBSP_SPCR1_RRST_DISABLE               /* RRST   = 0 */
  ),
  MCBSP_SPCR2_RMK(
    MCBSP_SPCR2_FREE_NO,                   /* FREE   = 0 */
    MCBSP_SPCR2_SOFT_NO,                   /* SOFT   = 0 */
    MCBSP_SPCR2_FRST_RESET,                /* FRST   = 0 */
    MCBSP_SPCR2_GRST_RESET,                /* GRST   = 0 */
    MCBSP_SPCR2_XINTM_XRDY,                /* XINTM  = 0 */
    0,                                     /* XSYNCER = N/A */
    MCBSP_SPCR2_XRST_DISABLE               /* XRST   = 0 */
  ),
  MCBSP_RCR1_RMK(
    MCBSP_RCR1_RFRLEN1_OF(0),              /* RFRLEN1 = 0 */
    MCBSP_RCR1_RWDLEN1_16BIT               /* RWDLEN1 = 4 */
  ),
  MCBSP_RCR2_RMK(
    MCBSP_RCR2_RPHASE_SINGLE,              /* RPHASE  = 0 */
    MCBSP_RCR2_RFRLEN2_OF(0),              /* RFRLEN2 = 0 */
    MCBSP_RCR2_RWDLEN2_16BIT,              /* RWDLEN2 = 0 */
    MCBSP_RCR2_RCOMPAND_MSB,               /* RCOMPAND= 0 */
    MCBSP_RCR2_RFIG_NO,                    /* RFIG    = 0 */
    MCBSP_RCR2_RDATDLY_1BIT                /* RDATDLY = 0 */
  ),
  MCBSP_XCR1_DEFAULT,
  MCBSP_XCR2_DEFAULT,
  MCBSP_SRGR1_DEFAULT,
  MCBSP_SRGR2_DEFAULT,
  MCBSP_MCR1_DEFAULT,
  MCBSP_MCR2_DEFAULT,
  MCBSP_PCR_RMK(
    MCBSP_PCR_XIOEN_SP,                     /* XIOEN    = 0   */
    MCBSP_PCR_RIOEN_SP,                     /* RIOEN    = 0   */
    MCBSP_PCR_FSXM_INTERNAL,                /* FSXM     = 1   */
    MCBSP_PCR_FSRM_EXTERNAL,                /* FSRM     = 0   */
    MCBSP_PCR_CLKXM_OUTPUT,                 /* CLKXM    = 1   */
    MCBSP_PCR_CLKRM_INPUT,                  /* CLKRM    = 0   */
    MCBSP_PCR_SCLKME_BCLK,                  /* SCLKME   = 1   */
    0,                                      /* DXSTAT = N/A   */
    MCBSP_PCR_FSXP_ACTIVEHIGH,              /* FSXP     = 0   */
    MCBSP_PCR_FSRP_ACTIVEHIGH,              /* FSRP     = 0   */
    MCBSP_PCR_CLKXP_RISING,                 /* CLKXP    = 0   */
    MCBSP_PCR_CLKRP_FALLING                 /* CLKRP    = 0   */
  ),
  MCBSP_RCERA_DEFAULT,
  MCBSP_RCERB_DEFAULT,
  MCBSP_RCERC_DEFAULT,
  MCBSP_RCERD_DEFAULT,
  MCBSP_RCERE_DEFAULT,
  MCBSP_RCERF_DEFAULT,
  MCBSP_RCERG_DEFAULT,
  MCBSP_RCERH_DEFAULT,
  MCBSP_XCERA_DEFAULT,
  MCBSP_XCERB_DEFAULT,
  MCBSP_XCERC_DEFAULT,
  MCBSP_XCERD_DEFAULT,
  MCBSP_XCERE_DEFAULT,
  MCBSP_XCERF_DEFAULT,
  MCBSP_XCERG_DEFAULT,
  MCBSP_XCERH_DEFAULT
};
DMA_Config  DRcvConfig = {
  DMA_DMACSDP_RMK(
    DMA_DMACSDP_DSTBEN_NOBURST,
    DMA_DMACSDP_DSTPACK_OFF,
    DMA_DMACSDP_DST_DARAMPORT1,
    DMA_DMACSDP_SRCBEN_NOBURST,
    DMA_DMACSDP_SRCPACK_OFF,
    DMA_DMACSDP_SRC_PERIPH,
    DMA_DMACSDP_DATATYPE_16BIT
  ),                                       /* DMACSDP  */
  DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT1
  ),                                       /* DMACCR   */
  DMA_DMACICR_RMK(
    DMA_DMACICR_AERRIE_ON,
    DMA_DMACICR_BLOCKIE_OFF,
    DMA_DMACICR_LASTIE_OFF,
    DMA_DMACICR_FRAMEIE_ON,
    DMA_DMACICR_FIRSTHALFIE_OFF,
    DMA_DMACICR_DROPIE_OFF,
    DMA_DMACICR_TIMEOUTIE_OFF
  ),                                       /* DMACICR  */
    0,                                     /* DMACSSAL */
    0,                                     /* DMACSSAU */
    0,                                     /* DMACDSAL */
    0,                                     /* DMACDSAU */
    576,                                   /* DMACEN   */
    1,                                     /* DMACFN   */
    0,                                     /* DMACSFI  */
    0,                                     /* DMACSEI  */
    0,                                     /* DMACDFI  */
    0                                      /* DMACDEI  */
};
static DMA_Config  DOutConfig = {
  DMA_DMACSDP_RMK(
    DMA_DMACSDP_DSTBEN_BURST4,
    DMA_DMACSDP_DSTPACK_OFF,
    DMA_DMACSDP_DST_EMIF,
    DMA_DMACSDP_SRCBEN_NOBURST,
    DMA_DMACSDP_SRCPACK_OFF,
    DMA_DMACSDP_SRC_DARAMPORT1,
    DMA_DMACSDP_DATATYPE_16BIT
  ),                                       /* DMACSDP  */
  DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_CONST,
    DMA_DMACCR_SRCAMODE_POSTINC,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_ENABLE,
    DMA_DMACCR_SYNC_NONE
  ),                                       /* DMACCR   */
  DMA_DMACICR_RMK(
    DMA_DMACICR_AERRIE_ON,
    DMA_DMACICR_BLOCKIE_OFF,
    DMA_DMACICR_LASTIE_OFF,
    DMA_DMACICR_FRAMEIE_ON,
    DMA_DMACICR_FIRSTHALFIE_OFF,
    DMA_DMACICR_DROPIE_OFF,
    DMA_DMACICR_TIMEOUTIE_OFF
  ),                                       /* DMACICR  */
    0,                                     /* DMACSSAL */
    0,                                     /* DMACSSAU */
    0,                                     /* DMACDSAL */
    0,                                     /* DMACDSAU */
    512,                                   /* DMACEN   */
    1,                                     /* DMACFN   */
    0,                                     /* DMACSFI  */
    0,                                     /* DMACSEI  */
    0,                                     /* DMACDFI  */
    0                                      /* DMACDEI  */
};
delay() { int i; for(i=0;i<300*80;i++)asm(" NOP "); }
void init_pll(void)
{ PLL_setFreq(1,12,0,1,3,1,1); delay(); }
void init_dmaAD(Uint16 *addr)
{
  Uint16 srcAddrHi, srcAddrLo;
  Uint16 dstAddrHi, dstAddrLo;
  Uint16 val;
  srcAddrHi = (Uint16)(((Uint32)(MCBSP_ADDR(DRR10))) >> 15) & 0xFFFFu;
  srcAddrLo = (Uint16)(((Uint32)(MCBSP_ADDR(DRR10))) << 1) & 0xFFFFu;
  dstAddrHi = (Uint16)(((Uint32)(addr)) >> 15) & 0xFFFFu;
  dstAddrLo = (Uint16)(((Uint32)(addr)) << 1) & 0xFFFFu;
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_ON,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_HI,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT0
  );
  DRcvConfig.dmacssal = (DMA_AdrPtr)srcAddrLo;
  DRcvConfig.dmacssau = srcAddrHi;
  DRcvConfig.dmacdsal = (DMA_AdrPtr)dstAddrLo;
  DRcvConfig.dmacdsau = dstAddrHi;
  DMA_config(hDma0, &DRcvConfig);
  srcAddrHi = (Uint16)(((Uint32)(MCBSP_ADDR(DRR11))) >> 15) & 0xFFFFu;
  srcAddrLo = (Uint16)(((Uint32)(MCBSP_ADDR(DRR11))) << 1) & 0xFFFFu;
  dstAddrHi = (Uint16)(((Uint32)(addr+576)) >> 15) & 0xFFFFu;
  dstAddrLo = (Uint16)(((Uint32)(addr+576)) << 1) & 0xFFFFu;
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_ON,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_HI,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT1
  );
  DRcvConfig.dmacssal = (DMA_AdrPtr)srcAddrLo;
  DRcvConfig.dmacssau = srcAddrHi;
  DRcvConfig.dmacdsal = (DMA_AdrPtr)dstAddrLo;
  DRcvConfig.dmacdsau = dstAddrHi;
  DMA_config(hDma1, &DRcvConfig);
  val = *ConMcbsp2; val |= 4;
  *ConMcbsp2 = val;
  srcAddrHi = (Uint16)(((Uint32)(MCBSP_ADDR(DRR12))) >> 15) & 0xFFFFu;
  srcAddrLo = (Uint16)(((Uint32)(MCBSP_ADDR(DRR12))) << 1) & 0xFFFFu;
  dstAddrHi = (Uint16)(((Uint32)(addr+1152)) >> 15) & 0xFFFFu;
  dstAddrLo = (Uint16)(((Uint32)(addr+1152)) << 1) & 0xFFFFu;
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_ON,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_HI,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_REVT2
  );
  DRcvConfig.dmacssal = (DMA_AdrPtr)srcAddrLo;
  DRcvConfig.dmacssau = srcAddrHi;
  DRcvConfig.dmacdsal = (DMA_AdrPtr)dstAddrLo;
  DRcvConfig.dmacdsau = dstAddrHi;
  DMA_config(hDma2, &DRcvConfig);
}
void InitFifoInf(void)
{
  PREG16(0x0801) = 0x0009; //ECLKOUT2 enable  4*EMIF CLOCK
  PREG16(0x0804) = 0x8111; //16bit Async
  PREG16(0x0805) = 0x81F3;
  PREG16(0x0824) = 0x0045;
  if(REG16(REG_DSP_IDX)==0){
    PREG16(0x3400) |=  (0x01<<2); //IODIR GPIO2 output
    PREG16(0x3400) &= ~(0x01<<4); //IODIR GPIO4 input
    PREG16(0x3401) &= ~(0x01<<2); //IODATA GPIO2 not request
    PREG16(0x3400) &= ~(0x01<<6); //IODIR GPIO6 input
    PREG16(0x3400) |=  (0x01<<7); //IODIR GPIO7 output
    PREG16(0x3401) |=  (0x01<<7); //IODATA GPIO7
  } else {
    PREG16(0x3400) |=  (0x01<<6); //IODIR GPIO6 output
    PREG16(0x3400) &= ~(0x01<<7); //IODIR GPIO7 input
    PREG16(0x3401) &= ~(0x01<<6); //IODATA GPIO6 not request
    PREG16(0x3400) &= ~(0x01<<2); //IODIR GPIO2 input
    PREG16(0x3400) |=  (0x01<<4); //IODIR GPIO4 output
    PREG16(0x3401) |=  (0x01<<4); //IODATA GPIO4
  } PREG16(0x3400) &=~0x3;        //GPIO0,1 input
}
void Start_DmaOut(Uint32 src, Uint32 des)
{
  OutDmaBusy = 1;
  DOutConfig.dmacssal = (DMA_AdrPtr)(src&0xFFFF);
  DOutConfig.dmacssau = (src>>16)&0xFFFF;
  DOutConfig.dmacdsal = (DMA_AdrPtr)(des&0xFFFF);
  DOutConfig.dmacdsau = (des>>16)&0xFFFF;
  DMA_config(hDmaOut, &DOutConfig);
  DMA_start(hDmaOut);
}
Uint8 * BuildBlockPad(Uint8 blocktype, Uint16 blocklengh,Uint8 blocknum)
{
  BlockPad.magic_1 = 'A';
  BlockPad.magic_2 = 'B';
  BlockPad.magic_3 = 'C';
  BlockPad.magic_4 = 'D';
  BlockPad.magic_5 = 'E';
  BlockPad.magic_6 = 'F';
  BlockPad.magic_7 = 'G';
  BlockPad.magic_8 = 'H';
  BlockPad.magic_9 = 'I';
  BlockPad.Block_lengh_L = blocklengh&0x00ff;
  BlockPad.Block_lengh_H = (blocklengh>>8)&0x00ff;
  BlockPad.Block_type = (blocknum & 0x7f) | ((blocktype==0)?0x00:0x80);
  return (Uint8*)&BlockPad;
}
Uint16 * BuildPagePad(Uint16 type, Uint8 page_no, Uint16 page_dpi, Uint8 layers)
{
                                         PagePad.chksum  = 0;
  PagePad.magic_a = PAD_MAGIC_1;         PagePad.chksum += PagePad.magic_a;
  PagePad.magic_b =~PAD_MAGIC_1;         PagePad.chksum += PagePad.magic_b;
  PagePad.magic_c = PAD_MAGIC_2;         PagePad.chksum += PagePad.magic_c;
  PagePad.magic_d =~PAD_MAGIC_2;         PagePad.chksum += PagePad.magic_d;
  PagePad.pad_type= type;                PagePad.chksum += PagePad.pad_type;
  PagePad.page_no = (layers<<8)|page_no; PagePad.chksum += PagePad.page_no;
  PagePad.page_dpi= page_dpi;            PagePad.chksum += PagePad.page_dpi;
                                         PagePad.chksum  =~PagePad.chksum;
  return (Uint16*)&PagePad;
}

sort1(x,m)
short *x; int m;
{ int i,j,k;
  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(x[i]>x[j]){k=x[i]; x[i]=x[j]; x[j]=k;}
}

XGD_int0()
{
  int i,j,k;
  if(n1){       
// search TBT_posi  taiwan:  37~56     our:      28~47
    k=n2+1000;
    for(i=0;i<n3;i++)if(xy[i]<100)             // save 100 array_union
      if(ab[i+100])xy[i]++;                    // for search barT=1 only
      else if(xy[i]>i35 && xy[i]<i75)xy[i]=k-xy[i]/2; else xy[i]=0; //xy[]
    j=k=0; for(i=27;i<58;i++)k+=ab[i]; if(k>=15)j=1000;   // if TBT_line
    j1=k=0;
    for(i=60;i<n1;i++)
      if(ab[i])k++; else { if(k>35 && k<75)j1=i-k/2;  k=0; }
    xx[n2++]=j1+j;  if(n2>=1924)n2=1924-1;     // TBT(j)+X_posi   xx[]
    if(j)for(i=20;i<864;i++)yy[i]+=ab[i];      //                 yy[]
  } 
  ab[0]=0;
}

cut38()
{
  int i,j,k;
  if(docut38 )return;
  barL=(dpi==100)?50:100;
  zz(0x7ffb)=n2;
// right edge:
  k=yy[863]/2;
  if(k<99)i=863; else for(i=862;i>432;i--)if(yy[i]<k)break; n1=i;
// how mary TBT
  for(i=1;i<n2-1;i++)if(xx[i]<999 && xx[i-1]>999 && xx[i+1]>999)xx[i]=1000;
  k=0; for(i=1;i<n2-20;i++)if(xx[i]>999 && xx[i-1]<999)k++;
//  printf("n_TBT: %d  ",k);               // -->[0x7fd0] == stop[0]
  zz(0x7fd0)=k;
  zz(0x7fd1)=h999;        
  zz(0x7fd2)=1;
  zz(0x7fd3)=zz(0x7fd4)=0;
// workout barT barX barY barL, search Y_dir bar 1st
  j1=j2=j4=barT=0; j3=10;
  for(i=j3;i<n2-10;i++){ if(xx[i]>=1000)xx[i]-=1000;    // de TBT
                         if(xx[i])j4=i+1; }             // last one
  if(j4<99)goto l40;
l30:
  for(i=j3;i<j4;i++){ if(xx[i]){ j1=i; break; } }
  if(i==j4)goto l40;
  for(i=j1;i<j4;i++){ if(xx[i]){ j2=i; k=0; } else k++; if(k>20)break; }
  if(j2-j1<barL){ j3=i;   goto l30; }
  j=0; for(i=j1;i<=j2;i++)if(xx[i]){ xx[j++]=xx[i]; if(j>9)break; }
  sort1(xx,9); barT=2; barX=xx[4]; barY=j1-20; barL=j2-j1+40;
l40:
  if(barT==0){                                      // if barY fail
    j1=j2=j4=0; j3=10;
    for(i=j3;i<700;i++){ if(xy[i]>=1000)xy[i]-=1000; else xy[i]=0;
                           if(xy[i])j4=i+1; }   // lastone
    if(j4<99)goto l60;
l50:
    for(i=j3;i<j4;i++){ if(xy[i]){ j1=i; break; } }
    if(i==j4)goto l60;
    for(i=j1;i<j4;i++){ if(xy[i]){ j2=i; k=0; } else k++; if(k>20)break; }
    if(j2-j1<100){ j3=i; goto l50; }
    j=0; for(i=j1;i<=j2;i++)if(xy[i]){ xy[j++]=xy[i]; if(j>9)break; }
    sort1(xy,9); barT=1; barX=j1+80; barY=xy[4]; barL=j2-j1+40;
                 if(dpi==100)barY+=4;
  }
l60:
//  printf("barT,barX,barY,barL:  %d %d %d %d  ",barT,barX,barY,barL);
  zz(0x7fca)=barT;
  zz(0x7fcb)=barX*2;
  zz(0x7fcc)=barY*2;
  zz(0x7fcd)=barL*2;
// get TBT posi, taiwan(>42) or china (<42)
  j=(56+28)/2; k=yy[j]/2;
  for(j1=j-1;j1>=24;j1--)if(yy[j1]<k)break;
  for(j2=j+1;j2<=60;j2++)if(yy[j2]<k)break;
  x=(j1+j2)*0.5;
  p41[0]=x*2.+1.;
  j=zz(0x7f93)&0xff;                      //       c5502 fixed omr_card_sort
  if(j>9){ 
    if(x>42.){ j=zz(0x7f94)=0; zz(0x7f95)=200; } 
    else style123(x,&j);      // auto match, use yy[]
  }
  if(j<=9 && j>3){ 
    if(j==9){ zgym[4]=zz(0x7f96)*0.01; igym[4]=zz(0x7f97); }
    j=4;
  }
  z=zgym[j]; x+=z+igym[j];   // why +1,not 0.5;  because odd_line shift 1 pixel
  for(k=1;k<41;k++){ x+=z; p41[k]=x*2.+1.; if(x+z>n1)break; }
  if(x+z/2<n1)k++;       if(k>41)k=41;
//  printf("n41: %d step_width:%6.2f (%c)  real_width: %d  ",k,z,cgym[j],n1);
  
//  for(i=0;i<k;i++)printf("%d ",p41[i]); printf("\n");
  zz(0x7fa0)=k;
  for(i=0;i<k;i++)zz(0x7fa1+i)=p41[i];
// recover omr to normal status
  zz(0x7f98)=1;
//  data up  
  a[0]=253;
  docut38=1;
  zz(0x7f93)=0xffff;                 // 2014,3,25
}

style123(x9,i9)                       // x9: TBT_posi; i9: output
float x9; int *i9;
{
  int i,i1,i2,j,k,u[4]; float x,z,z2,y[4];
  for(i=1;i<4;i++){
    z=zgym[i]; x=x9+z+igym[i];   i1=i2=0; z2=z/2.;
    for(k=1;k<41;k++){ x+=z;     if(x+z2>n1)break;
      j=x+0.5;    i1+=yy[j];  j=x+0.5+z2; i2+=yy[j];
    } y[i]=i1; if(i2)y[i]/=i2; else y[i]=100.; u[i]=i;
//   printf("%c %5.2f %d ==> %5d %5d %6.2f\n",cgym[i],z,k,i1,i2,y[i]);
  }
  for(i=1;i<3;i++)for(j=i+1;j<4;j++)if(y[i]<y[j]){
    x=y[i]; y[i]=y[j]; y[j]=x; k=u[i]; u[i]=u[j]; u[j]=k;
  }
  x=y[1]/y[2];
  if(x>1.2 || y[1]>1.5)k=u[1];
  else  { k=2; if(u[1]!=2)x=y[2]/y[1]; }
//  printf("%5.2f   ",x);
  *i9=k;
  zz(0x7f94)=k;  k=x*100.+0.5; zz(0x7f95)=k;
}

cut()
{
  int i,j,k,l, k20,k33, sx,sz, points,sort[9];
L3:
  if(fch-half<nx) return;                    /* data not buffered yet */
  nx++;  cc=aa[(nx&0x3f)*n48];
  if(cc>63){ 
    if(barT)do_bar();
    cutdone=1;
    n41=0;
    a[0]=255;
    return; }   /* finish */
  if(cc+2>=p40 && ipp==0)goto L3;            /* for 1ST black */
  ipp=255;
  if(jp==0){                                 /* find 1st mark */
    for(i=0;i<n41;i++){ sz=aa[(nx&0x3f)*n48+i]; if(bias[i]>sz)bias[i]=sz; }
    k=0; for(i=0;i<n41;i++)if(bias[i]>k)k=bias[i];
    if(k>m40/2){ ipp=0; goto L3; }             // bias not standable
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1; }     /* find left_edge */
    if(ipeak==1 && cc<p40) {                          /* find right_edge */
      x_c=xpeak=(ns+nx)>>1;  x_w=6;
      if(nx-ns <p6 )goto L99;
      for(i=1;i<n41;i++){                             /* cal slip */
        k=sx=cc=0;
        for(j=xpeak-x_w;j<=xpeak+x_w;j++){
          sz=aa[(j&0x3f)*n48+i];  if(sz>cc)cc=sz;
          k+=(sz*(j-xpeak));
          sx+=sz;
        }
        if(sx<1)sx=1;   xpeak+=(k*2/sx+1)>>1;
        slip[i]=xpeak-x_c;                            /* if end */
        l=aa[(xpeak&0x3f)*n48+i]-cc;
        if(l<0)l=-l; if(l>sigma)slip[i]=slip[i-1];
        cc=cc*3/4; k=xpeak-30; if(k<10)k=10;
        l=1; for(j=xpeak;j>k;j--)if(cc>aa[(j&0x3f)*n48+i]){ l=0; break; }
        if(l){ slip[i]=slip[i-1]; if(i==15)break; }   /* no black line */
      }
      jp=1;
      return;
    }
  }
  if(jp){
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1;    }  /* find left */
    if(ipeak==1 && cc<p40) {                          /* find right */
      xpeak0=xpeak;    xpeak=(ns+nx)>>1;
      if(nx-ns <p6 )goto L99;
      x_w=(nx-ns)>>1;  if(x_w>hwmax)x_w=hwmax;
      if(nx-ns-3 > dp && jp>3){
        xpeak=xpeak0; nx=xpeak+(dp*5)/4;  xpeak0=nx+dp/2;
        for(i=nx;i<xpeak0;i++)aa[(i&0x3f)*n48]=bias[0];
        goto L3;
      }
      l=xpeak-xpeak0;
      if(jp==2 || (jp==3 && l<dp)) { dp=l; dx=nx-ns+3; }
      if(jp>3 && nx-ns>dx) xpeak=xpeak0+dp;
      if(jp==1){
        p40=(aa[(xpeak&0x3f)*n48]-bias[0])/2+bias[0];
        if(p40>45)p40=45; if(p40<36)p40=36;
      }
      for(i=1;i<n41;i++){
        k=xpeak+slip[i];
        c= points=0; bias3=3*(p60-bias[i])/15+bias[i];  /* find peak */
        for(j=k-x_w;j<=k+x_w;j++){
          sz=aa[(j&0x3f)*n48+i];
          if(sz>c){ c=sz; x_c=j; }                      /* find posi */
          if(sz>bias3)points++;
        }
        calcck20(i);
        if(cc<=1){
          l=0; for(j=k-4;j<=k+4;j++)sort[l++]=aa[(j&0x3f)*n48+i];
          for(j=0;j<8;j++)for(l=j+1;l<9;l++)if(sort[j]>sort[l]){
            k20=sort[l]; sort[l]=sort[j]; sort[j]=k20;
          }
          j=bias[i]-sort[4]; if(j<0)j=-j;
          bias[i]=(j<=sigma)?sort[4]:(bias[i]+sort[4])/2;
        }
        if(cc<p3)cc=0; else if( points*3 < x_w*2 )jduge(i,k);
        if(cc>m5){
          k20=findk(i,20);   k33=findk(i,33); if(k20==0)k20=1;
          k=40-(k33*24/k20); k=findk(i,k);
          l=k/6; if(l>7)l=7; l<<=4;   cc|=l;
        }
        a[i]=cc; c_xpeak[i]=x_c-xpeak;
      }
      a[0]=jp;                              // for usb transfer data
      for(i=1;i<n41;i++)if(a[i]==0)goto l50;
      ist4=jp;
      shift=c_xpeak[n41-1]-slip[n41-1]; if(shift<0)shift+=128;
l50:
      jp++;  ipeak=0;
    }
  } goto L3;
L99:
  ipeak=0; goto L3;
}

jduge(int i,int k)
{
  int j,sz;
  if(aa[((k-x_w)&0x3f)*n48+i]>=bias3){
    for(j=k-x_w;j>=k-2*x_w;j--){ sz=aa[(j&0x3f)*n48+i];
      if(sz>c)c=sz; if(sz<bias3){ calcck20(i); return; }
    } cc=0;
  }
  if(aa[((k+x_w)&0x3f)*n48+i]>=bias3){
    for(j=k+x_w;j<=k+2*x_w;j++){ sz=aa[(j&0x3f)*n48+i];
      if(sz>c)c=sz; if(sz<bias3){ calcck20(i); return; }
    } cc=0;
  }
}

calcck20(int i)
{ cc=(c-bias[i])*15/(p60-bias[i]);  if(cc>15)cc=15; if(cc<0)cc=0; }

int findk(int i, int kk)
{
  int j,k,m20,m80,sz;
l20:
  m80=(c-bias[i])*9/10+bias[i]; k=0;
  m20=(c-bias[i])*kk/100; if(m20<sig20)m20=sig20; m20+=bias[i];
  for(j=x_c;j>x_c-p60;j--){ sz=aa[(j&0x3f)*n48+i];
    if(sz<m80)k++; if(c<sz){ c=sz; goto l20; }
    if(sz<m20)break;
  }
  for(j=x_c;j<x_c+p60;j++){ sz=aa[(j&0x3f)*n48+i];
    if(sz<m80)k++; if(c<sz){ c=sz; goto l20; }
    if(sz<m20)break;
  } return(k);
}

do_bar()
{
  bs=mark(); /* bs=0~ok, 1~nocode,2~nohead,3~noend,4~crc,5~nodata  */
}

mark()
{
  int i,j,k,l,bs, zm,mz,zp, checkcode, codesort, rsh[100],slp[100];
/*
  mz=m60;
  for(i=0;i<barL;i++){
    if(b[i]<m40 || b[i]<b[i-1] || b[i]<b[i+1])continue; if(b[i]<mz)mz=b[i];
  }
  bs=0;
  for(i=60;i<barL-60;i++){
    if(b[i]>m40 || b[i]>b[i-1] || b[i]>b[i+1])continue; if(b[i]>bs)bs=b[i];
  }
  bs=(mz-bs+1)/2;
  if(bs>p10)bs=p10;
  if(bs<p10/2)bs=p10/2;
  zm=mz-bs;
*/
  zm=30;                      // 2014,3,25
  zp= j= slp[0]=0;
  for(i=0;i<barL;i++){
    if(zp==0 && b[i]<zm)continue;
    if(zp==0){ zp=1;  slp[j++]=calm(i,zm); }
    if(zp==1){ if(b[i]<zm){ slp[j++]=calm(i,zm); zp=2; } continue; }
    if(zp==2)  if(b[i]>zm){ slp[j++]=calm(i,zm); zp=1; }
  }
  j--; for(i=1;i<j;i++)rsh[i-1]=(slp[i]-slp[i-1]+17)/33;
  l=0; k=j; if(rsh[1]>white8)l=2; if(rsh[k-2]>white8)k=k-2;
  mz=(k-l)/6;
  if(mz==0)return(5);                              /* no data */
  zm=(slp[mz*6+l]-slp[l])/(11*mz);
  for(i=l+1;i<=k;i++){
    bs=slp[i]-slp[i-1];
    if(bs<(zm*3/4)){ bs=(zm-bs)/2; slp[i]+=bs; slp[i-1]-=bs; }
  }
  j=0; for(i=l+1;i<=k;i++)slp[j++]=slp[i]-slp[i-1];
  if(slp[3]<slp[j-4])                              /* reversed */
    for(i=0;i<j/2;i++) { bs=slp[i]; slp[i]=slp[j-i-1]; slp[j-i-1]=bs;}
  for(i=0;i<j-1;i+=6){
    zp=(slp[i]+slp[i+1]+slp[i+2]+slp[i+3]+slp[i+4]+slp[i+5]+zm/2)/11;
    for(l=i;l<i+6;l++){
      slp[l]=(slp[l]+zp/2)/zp; if(slp[l]==0)slp[l]=1; if(slp[l]>=5)slp[l]=4;
    }
  }
  for(i=zp=l=0;i<j;i+=6){
    bs=0; for(k=0;k<6;k++){bs<<=2; bs|=slp[l++]-1;}  slp[zp++]=bs;
  } zp--;
  checkcode= l= bs=0;
  for(i=0;i<zp;i++){
    for(j=0;j<107;j++)if(slp[i]==mta[j])goto l10;
    return(1);
l10:
    slp[l++]=j;
  } l--;
  codesort=slp[0]-102;
  if(codesort<1 || codesort >3)return(2);        /* no head */
  if(slp[l]!=106)return(3);                      /* no end */
  for(i=1;i<l;i++)checkcode+=slp[i-1]*(i-1);  checkcode+=slp[0];
  checkcode%=103;
  l--;  if(checkcode!=slp[l])bs=4;               /* err of check code */
  for(i=1;i<l;i++)
  if(codesort==3){
    if(slp[i]==102)continue;                     /* 40923 for UCC/EAN */
    if(slp[i]>=100)codesort=2;
    else { a[++bip]=slp[i]/10+48; a[++bip]=slp[i]%10+48; }
  } else { if(slp[i]==99)codesort=3; else a[++bip]=slp[i]+32; }
  return(bs);
}

int calm(int i,int zm)
{
  if(b[i]==b[i-1])return i*10;
  return  i*10-(b[i]-zm)*10/(b[i]-b[i-1]);
}

work(WORD *a1728)
{
  int i,j,k,m,p;
  WORD *paa;
  if(fch>9 && topM==0){                    // get topM
    k=0; for(i=840-100;i<840+100;i++)if(a1728[i]<150)k++;
    if(k<9)topM10++; else topM10=0;
    if(topM10>9)topM=fch-topM10;           // topM delay 10_int0, open face  
    if(job && topM && zz(0x7fce)==0 ){
      for(k=1727;k>999;k--)if(a1728[k]>150)break; k-=15; // 15=0.4*gap
      for(i=0;i<n41;i++)if(p41[i]>k)break;
      n41=i;                              // n41 adjust, only do once
    }
  }
  if(fch>h999 && endM==0){                   // get endM  
    k=0; for(i=40;i<999;i++)if(a1728[i]>150/2)k++;
    if(k<9){ endM=fch;  n1=0; 
      zz(0x7ffe)=topM; zz(0x7fff)=endM;
      if(job){
        aa[((fch-1)&0x3f)*n48]=255;          // make cut_end_marker
        aa[((nx+1)&0x3f)*n48]=255; m255=0;
      }
    }
  }

  if(job){
    k=864;                               // extract for cut (omr2000)
    p=(fch&0x3f)*n48; paa=(WORD*)(&aa[p]); 
    for(i=0;i<n41;i++){
      if(endM!=fch){
        j=p41[i];
        m=a1728[j-2]+a1728[j-1]+a1728[j]+a1728[j+1]+a1728[j+2];
        m*=6; m>>=7;
        aa[p++]=63-m;                    // send cut_data
      } else  aa[p++]=255;               // make cut_data_end_mark
    }
    if(topM && barT && bz<barL){             // extract bar data
      if(barT==1 && fch==topM+barY){
        for(i=barX;i<barX+barL;i++){ b[bz++]=63-(a1728[i]>>2);
                                     if(m255)a1728[i]=255; }
      }
      if(barT==2 && fch>=topM+barY){
        b[bz++]=63-(a1728[barX]>>2); if(m255)a1728[barX]=255;
      }
    }
    if(m255 && topM)for(i=0;i<n41;i++)a1728[p41[i]]=255;  // mark ext position
  }

  k=8;                                    // line head (AA55..) position
  for(i=16+(fch%2);i<1728;i+=2)a1728[k++]=a1728[i]; // put shrink scan line
  a1728[k++]=n41;
  if(job){
    for(i=0;i<n41;i++)a1728[k++]=*paa++;
    for(i=k;i<864+42+42;i++)a1728[i]=0;     // clear 0
  } else a1728[906]=a1728[907]=0;
}

stop_omr()
{
  int i;
  a[0]=254; a[1]=error;       // 254, mid_sop,  255 norm_stop, else =line
                              // 253, output 256byte from [0x7f80] in XGD
// need delay here, send above error message with scan data
  for(i=0;i<300;i++)delay();
  CS = ST_Idle;               // c52 change Curstate & renew BLOCK_head
  end40=80;                   // sendout end_mark 80 times
// stop action::
  MotorStop();
}

init_c5502()
{
  int i;
  far_poke(0x008000+0x02,0);
  FifoBase[0] = 0x10000;
  FifoBase[1] = 0x10001;
  FifoBase[2] = 0x10002;
  FifoBase[3] = 0x10003;
  IRQ_setVecs((Uint32)(&VECSTART));
  hMcbsp0 = MCBSP_open(MCBSP_PORT0, MCBSP_OPEN_RESET);
  hMcbsp1 = MCBSP_open(MCBSP_PORT1, MCBSP_OPEN_RESET);
  hMcbsp2 = MCBSP_open(MCBSP_PORT2, MCBSP_OPEN_RESET);
  hDma0 =   DMA_open(DMA_CHA2,DMA_OPEN_RESET);
  hDma1 =   DMA_open(DMA_CHA3,DMA_OPEN_RESET);
  hDma2 =   DMA_open(DMA_CHA4,DMA_OPEN_RESET);
  hDmaOut = DMA_open(DMA_CHA1,DMA_OPEN_RESET);
  DmaEventID0 = DMA_getEventId(hDma0);
  DmaEventID1 = DMA_getEventId(hDma1);
  DmaEventID2 = DMA_getEventId(hDma2);
  DmaEventOutID = DMA_getEventId(hDmaOut);
  IRQ_clear(DmaEventID0);
  IRQ_clear(DmaEventID1);
  IRQ_clear(DmaEventID2);
  IRQ_clear(DmaEventOutID);
  IRQ_clear(IRQ_EVT_INT0);
  IRQ_clear(IRQ_EVT_INT2);
  IRQ_plug(DmaEventID0,  &DmaISR0);
  IRQ_plug(DmaEventID1,  &DmaISR1);
  IRQ_plug(DmaEventID2,  &DmaISR2);
  IRQ_plug(DmaEventOutID,&DmaOutISR);
  IRQ_plug(IRQ_EVT_INT0, &Int0ISR);
  IRQ_plug(IRQ_EVT_INT2, &Int2ISR);
  IRQ_enable(DmaEventOutID);
  IRQ_enable(IRQ_EVT_INT0);
  IRQ_enable(IRQ_EVT_INT2);
  MCBSP_config(hMcbsp0, &McbspRcvConfig);
  MCBSP_config(hMcbsp1, &McbspRcvConfig);
  MCBSP_config(hMcbsp2, &McbspRcvConfig);
  IRQ_globalEnable();
  FifoTransferRelease();
  REG16(REG_SW_VER)     = 0x4424;        // version
  REG16(REG_PG_status)  = 0;
  REG16(REG_PAGE_IDX)   = 0;
  REG16(REG_LINE_IDX)   = 0;
  REG16(REG_EINT_CNT)   = 0;
  REG16(REG_RX0INT_CNT) = 0;
  REG16(REG_RX1INT_CNT) = 0;
  REG16(REG_RX2INT_CNT) = 0;
  REG16(REG_LINE_CNT)   = 0;
  REG16(REG_TXINT_CNT)  = 0;
  REG16(REG_SCAN_LAYERS) =0;  // if load, set 1 or 2
  asm(" RSBX XF ");
  CurLayer  = 0;
  CurPageNo = 1;
  fch = old_fch = 0;
  for(i=2; i< 16;i++)zz(0x7f90+i)=0xffff;        // 7f92-7f9f
  for(i=-1;i< 56;i++)zz(0x7fa0+i)=0;             // 7f9f-7fd5
  for(i=6; i< 48;i++)zz(0x7fd0+i)=0xffff;        // 7fd6--
}

usb_ext(int n)             // not produced by scanning, n BLOCK_mark
{
  int i,j,k;  WORD u3;
  u3=u1;  u3++; u3&=3; usb1=(WORD*)(usb_address+u3*512);
  k=BLOCKPAD_SIZE+n*PAD_SIZE*2;
  blockpad = BuildBlockPad(machine,k,BlockNum);
  BlockNum = (BlockNum+1)&0x7f; REG16(REG_LINE_CNT)++;
  k=0;
  for(i=0;i<BLOCKPAD_SIZE;i+=2)usb1[k++]=blockpad[i] | (blockpad[i+1]<<8);
  for(i=0;i<n;i++)for(j=0;j<PAD_SIZE;j++)usb1[k++]=pagepad[j];
  j=0;
  for(i=5;i<k;i++){ j+=usb1[i]&0xFF; j+=(usb1[i]>>8)&0xFF; }
  j+=(usb1[4]>>8)&0xFF; usb1[4]=(usb1[4]&0xFF00) | (j&0xFF);
  u1 = u3;
}

void main()
{
  int i;
  int saveirq;
  Uint32 MainLoopCnt = 0;

  IRQ_globalDisable();
  CSL_init();
  init_pll();
  InitFifoInf();
  init_c5502();

  for(i=0;i<0xc80;i++)tmp[i]=0;

l10:
  if(fch==0){
    machine=REG16(REG_DSP_IDX); if(machine)machine=1;
    dpi=REG16(REG_SCAN_DPI);      
            h999=999; p6=8; d_m=0; i35=35; i75=75; // bit1: 0~200,2~100dpi
    if(dpi==100){ h999=499; p6=4; d_m=2; i35=18; i75=38; }
    d_m+=machine;
    job=zz(0x7f98);
    error=topM=topM10=endM=a[0]=0;
    if(job){
      m255=zz(0x7f9f);
      n41 =zz(0x7fa0); if(n41>41)n41=41; 
      barT=zz(0x7fca);   // barT=0,1,2
      barX=zz(0x7fcb);
      barY=zz(0x7fcc);
      barL=zz(0x7fcd); if(barL>600)barL=600; if(barT==0)barL=0;
                       if(barX>1728-1-barL)barX=1728-1-barL;
      p60=m60; p40=m40; shift=64;
      for(i=0;i<n41;i++){ bias[i]=p60; slip[i]=0; }
      ipp=jp=nx=ipeak= bz=bip=bs=cutdone=0;
    } else {
      docut38=initXGD=n1=n2= barT=m255=ab[0]=0;
      for(i=0;i<700;i++)xy[i]=0;
      for(i=0;i<864;i++)yy[i]=0;
    }
  }
  if(job){
    if(stop[0])if(cutdone)if(stop[0]!=jp-1)error=1;    // omr2000 line error.
    if(stop[1])if(fch>stop[1] && jp==0)error=2;        // after n line, no block
    if(stop[2])if(bs)error=3;                          // bar error
    if(stop[3])if(jp==stop[3]+1)
               if(ist4!=stop[3])error=4;               // checkline posi_err 
    if(stop[4])if(jp==stop[4]+1)
               if((a[stop[5]]&0xf)<5)error=5;          // no write mark
    if(error)stop_omr();
  }
  if(fch!=old_fch){    old_fch=fch;
    if(job){
      if(n41  && error==0 )cut();
    } else {
      if(ab[0])XGD_int0();     // during  topM ~ endM period
      if(endM) cut38();        // after endM, do once
    } 
  }

  if((REG16(REG_PG_status)==1) && (CS==ST_Idle)){
    saveirq = IRQ_globalDisable();
    REG16(REG_PG_status) = 0;     // set [7f83]=0, c52 know new page begin
    IRQ_globalRestore(saveirq);

    CurPageNo = REG16(REG_PAGE_IDX);
    pagepad = BuildPagePad(START_PAD,CurPageNo,dpi,REG16(REG_SCAN_LAYERS));

    BlockNum = fch = old_fch = end40 = 0;   // jiang add
    REG16(REG_LINE_CNT) = REG16(REG_TXINT_CNT)= 0;
    ist4=0;

    usb_ext(10);
    pagepad = BuildPagePad(END_PAD,CurPageNo,dpi,REG16(REG_SCAN_LAYERS));
    CS = ST_Scan;  
    MotorRestart();
  } else

  if((REG16(REG_PG_status)==2) && (CS==ST_Scan)){
    saveirq = IRQ_globalDisable();
    REG16(REG_PG_status) = 0;     // tell hardware, message has taken
    IRQ_globalRestore(saveirq);
    CS = ST_Idle;                
    end40 = 80;                   //  send end_mark 80k byte, else cant work
  }                               //  minum is 32, but not standable.
  if(end40 && u1==u2){ end40--; usb_ext(60); }

  if(u1!=u2 && !OutFifoBusy)  {
    saveirq = IRQ_globalDisable();
    TryFifoTransferRequest();         // 1st place, real send data
    OutFifoBusy = 1;
    IRQ_globalRestore(saveirq);
  }

  if(MainLoopCnt&0x100000)asm(" RSBX XF ");
  else  asm(" SSBX XF ");
  if((MainLoopCnt&0x1FFF)==0x100) REG16(REG_DSP_SR)++;
  MainLoopCnt++;

  goto l10;
}

interrupt void DmaISR0(void)
{
  IRQ_clear(DmaEventID0);
  REG16(REG_RX0INT_CNT)++;
  MCBSP_reset(hMcbsp0);
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_NONE
  );
  DMA_config(hDma0, &DRcvConfig);
  DMA_stop(hDma0);
}
interrupt void DmaISR1(void)
{
  IRQ_clear(DmaEventID1);
  REG16(REG_RX1INT_CNT)++;
  MCBSP_reset(hMcbsp1);
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_NONE
  );
  DMA_config(hDma1, &DRcvConfig);
  DMA_stop(hDma1);
}
interrupt void DmaISR2(void)
{
  IRQ_clear(DmaEventID2);
  REG16(REG_RX2INT_CNT)++;
  MCBSP_reset(hMcbsp2);
  DRcvConfig.dmaccr = DMA_DMACCR_RMK(
    DMA_DMACCR_DSTAMODE_POSTINC,
    DMA_DMACCR_SRCAMODE_CONST,
    DMA_DMACCR_ENDPROG_OFF,
    DMA_DMACCR_WP_DEFAULT,
    DMA_DMACCR_REPEAT_OFF,
    DMA_DMACCR_AUTOINIT_OFF,
    DMA_DMACCR_EN_STOP,
    DMA_DMACCR_PRIO_LOW,
    DMA_DMACCR_FS_DISABLE,
    DMA_DMACCR_SYNC_NONE
  );
  DMA_config(hDma2, &DRcvConfig);
  DMA_stop(hDma2);
}
interrupt void Int0ISR(void)
{
  int i,j,m; WORD k,u3;         //v
  register WORD *p0,*p1,*p2;    //*q0
  IRQ_clear(IRQ_EVT_INT0);
  if(FIRST == 0)  { FIRST = 1;
    BufDma = bufping;
    init_dmaAD(BufDma);
    DMA_start(hDma0); DMA_start(hDma1); DMA_start(hDma2);
    MCBSP_start(hMcbsp0,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp1,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp2,MCBSP_RCV_START,0);
  } else  {
    if(CS==ST_Scan) fch++;
    BufMain = BufDma;
    if(BufDma == bufping)      BufDma = bufpong;
    else if(BufDma == bufpong) BufDma = bufping;
    init_dmaAD(BufDma);
    DMA_start(hDma0); DMA_start(hDma1); DMA_start(hDma2);
    MCBSP_config(hMcbsp0, &McbspRcvConfig);
    MCBSP_config(hMcbsp1, &McbspRcvConfig);
    MCBSP_config(hMcbsp2, &McbspRcvConfig);
    MCBSP_start(hMcbsp0,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp1,MCBSP_RCV_START,0);
    MCBSP_start(hMcbsp2,MCBSP_RCV_START,0);
// add routine
    p2=p1=(WORD*)BufMain;
    j=CurLayer; if(zz(0x7f92)==0)j=-1; p0=(WORD*)(hb_tbl+j*1728);  //q0=p0;
//  if(zz(0x7fcf)==0){         // ** 7f84 **, 7fcf always=0, except test. 
      if(j>=0){                // B_data donot reverse, it canbe done at XP.
                               // otherwise, TBT isnot at 1ST area.        
        if(job){
          for(i=0;i<1728;i++){ 
            m=(*p0>>8)<<2; j= *p2&0x3ff;
            k=(j>m)?j-m:0; k*=(*p0++&0xff); k>>=6; if(k>254)k=254;
            *p2++=k;
          }
        } else { 
// for(i=0;i<40;i++)*p2++=0; p0+=40;
// for(i=40;i<1728-20;i+=2)
// ...
// for(i=0;i<20;i++)*p2++=0;
          for(i=0;i<1728;i+=2){              // only for save_time
            m=(*p0>>8)<<2; j= *p2&0x3ff;     // next, from i=40; 1728-20 ??
            k=(j>m)?j-m:0; k*=(*p0&0xff); p0+=2; k>>=6; if(k>254)k=254;
            *p2++=k; *p2++=k;   
          }
        }
      } else for(i=0;i<1728;i++)*p2++=(*p1++&0x3ff)>>2;
/*
    } else { p2+=1727; q0+=1727; machine=1;
      if(j>=0){                               // save time
        for(i=0;i<864;i++){           
          m=(*p0>>8)<<2; j= *p1&0x3ff;
          k=(j>m)?j-m:0; k*=(*p0++&0xff); k>>=6; if(k>254)k=254;
          m=(*q0>>8)<<2; j= *p2&0x3ff;
          v=(j>m)?j-m:0; v*=(*q0--&0xff); v>>=6; if(v>254)v=254;
          *p1++=v; *p2--=k;
        }
      } else for(i=0;i<864;i++){
        k=(*p1&0x3ff)>>2; v=(*p2&0x3ff)>>2;
        *p1++=v; *p2--=k;
      }
    }
*/
//  shrink & extract
    work(BufMain);          // usb1 as tmp in work()

    k=864+42;               // 906 start +42 =948
    if(a[0]){                                    // send bar result
      if(a[0]<=250){
        BufMain[k++]=n41; for(i=0;i<n41;i++)BufMain[k++]=a[i]; 
      } 
      if(a[0]==253){                             // in XGD, out [0x7f80--]
        BufMain[k]=1; BufMain[k+1]=a[0];         // [907]=253
      }                                       
      if(a[0]==254){                             // Motorstop
        BufMain[k]=3;
        BufMain[k+1]=a[0];                       // [907]=254
        BufMain[k+2]=a[1];
        if(a[1]==3){ BufMain[k]=4; BufMain[k+3]=bs; }  // bar_err
        error=0;
      }     
      if(a[0]==255){                             // bar last message         
        error=0;                  
        BufMain[k++]=bip+5; BufMain[k++]=255;    // [907]=255
        BufMain[k++]=error;                      // system error number
        BufMain[k++]=shift;                      
        BufMain[k++]=bs;                         // bar error_number
        BufMain[k++]=bip;
        for(i=1;i<=bip;i++)BufMain[k++]=a[i];    // bar 
      }
      a[0]=0;                                    // clear omr_result marker
    } 

    u3=u1;  u3++; u3&=3; usb1=(WORD*)(usb_address+u3*512);
    k=BLOCKPAD_SIZE+864+42+42;
    blockpad = BuildBlockPad(machine,k,BlockNum);
    BlockNum = (BlockNum+1)&0x7f; REG16(REG_LINE_CNT)++;
    k=0;
    for(i=0;i<BLOCKPAD_SIZE;i+=2)usb1[k++]=blockpad[i] | (blockpad[i+1]<<8); 
    usb1[k++] = 0xAA55;
    usb1[k++] = CurPageNo;
    usb1[k++] = CurLayer | (d_m<<8);         // jiang add, A,B machine & dpi   
    usb1[k++] = fch;  j=k;                   // bit1: 0~200;  1~100
    for(i=8;i<864+42+42;i+=2)usb1[k++]=BufMain[i] | (BufMain[i+1]<<8);
                                        // extract data for XGD_int0
    if(job==0 && (fch%2)==0 && topM && endM==0 ){  
      if(initXGD!=topM){                        // while fine Y1
        k=0; for(i=499;i<864;i++){
          if(BufMain[i]<150/2)k++; else k=0; if(k>5)break;
        }
        n1=i-k;                                   // find n1;
        n3=n1-30-100; if(n3>700)n3=700;           // for X_direction bar
        zz(0x7ffa)=n1; zz(0x7ffc)=n3;
        initXGD=topM;
      }
      ab[0]=1; for(i=20;i<864;i++)ab[i]=(BufMain[i]<150)?1:0;
    }

// out bar_data
    if(job && BufMain[907]>=254){  usb1[j++]=barL; 
      for(i=0;i<barL;i+=2)usb1[j++]=b[i] | (b[i+1]<<8);
    }
// out XGD_data
    if(job==0 && BufMain[907]==253){
      usb1[j++]=256;
      for(i=0;i<128;i++)usb1[j++]=zz(0x7f80+i);
    }
    j=0;  
    for(i=5;i<k;i++){ j+=usb1[i]&0xFF; j+=(usb1[i]>>8)&0xFF; }
    j+=(usb1[4]>>8)&0xFF; usb1[4]=(usb1[4]&0xFF00) | (j&0xFF);
    u1 = u3;
    
    if(!OutFifoBusy)  {
      k = IRQ_globalDisable();
      TryFifoTransferRequest();    
      OutFifoBusy = 1;
      IRQ_globalRestore(k);
    }
  }
  CurLayer = PREG16(0x3401)&0x03;//ȡڼ
}
interrupt void DmaOutISR(void)
{
  int saveirq;
  FifoTransferRelease();
  IRQ_clear(DmaEventOutID);
  DMA_stop(hDmaOut);
  OutDmaBusy = OutFifoBusy = 0;
  if(u1!=u2){                             // buf_usb
    saveirq = IRQ_globalDisable();
    TryFifoTransferRequest();             // 3th place,  real send
    OutFifoBusy = 1;
    IRQ_globalRestore(saveirq);
  }
  REG16(REG_DMAOUT_CNT)++;
}
interrupt void Int2ISR(void)   // put data to usb_buffer & DMA_req
{
  IRQ_clear(IRQ_EVT_INT2);
  asm(" nop ");asm(" nop ");asm(" nop ");asm(" nop ");
  if(!OutDmaBusy && OutFifoBusy && CheckFifoTransferAck()) {
    u2++; u2&=3; usb2=(WORD*)(usb_address+u2*512);  
    Start_DmaOut(((Uint32)usb2)<<1, (0x10000<<1));
    REG16(REG_TXINT_CNT)++;
  }
}
